// Code generated by tools/generate-lex-keyword.cpp. DO NOT EDIT.
// source: src/quick-lint-js/fe/keyword-lexer.h
// source: src/quick-lint-js/fe/keyword-list.h

// Copyright (C) 2020  Matthew "strager" Glazar
// See end of file for extended copyright information.

#include <cstddef>
#include <cstdint>
#include <quick-lint-js/fe/keyword-lexer.h>
#include <quick-lint-js/fe/lex.h>
#include <quick-lint-js/fe/token.h>
#include <quick-lint-js/port/char8.h>

namespace quick_lint_js {
namespace {
constexpr std::size_t hash_table_size = 512LLU;
constexpr std::size_t string_table_size = 446LLU;

constexpr keyword_lexer::seed_type hash_seed = 2166215926LLU;

struct entry {
  std::uint16_t key_index;  // Index into tables::string_table.
  std::uint8_t key_length;
  token_type value;
};

// The two tables are combined into one table to reduce the number of
// instructions dedicated to address computation in the lookup function. (I did
// not measure whether this technique actually improves performance, though.)
struct tables_type {
  entry hash_table[hash_table_size];
  char8 string_table[string_table_size];
};

// clang-format off
constexpr tables_type tables = {
    .hash_table =
        {
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {61, 4, token_type::kw_this},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {88, 6, token_type::kw_static},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {112, 7, token_type::kw_require},
            {253, 10, token_type::kw_implements},
            {263, 2, token_type::kw_if},
            {335, 7, token_type::kw_declare},
            {0, 0, token_type::identifier},
            {142, 7, token_type::kw_private},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {214, 9, token_type::kw_intrinsic},
            {406, 5, token_type::kw_async},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {401, 5, token_type::kw_await},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {318, 4, token_type::kw_else},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {301, 7, token_type::kw_extends},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {71, 6, token_type::kw_switch},
            {0, 0, token_type::identifier},
            {14, 4, token_type::kw_void},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {421, 8, token_type::kw_abstract},
            {167, 6, token_type::kw_object},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {34, 9, token_type::kw_undefined},
            {127, 6, token_type::kw_public},
            {0, 0, token_type::identifier},
            {149, 7, token_type::kw_package},
            {0, 0, token_type::identifier},
            {358, 5, token_type::kw_const},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {156, 8, token_type::kw_override},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {82, 6, token_type::kw_string},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {308, 6, token_type::kw_export},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {374, 5, token_type::kw_catch},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {388, 7, token_type::kw_boolean},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {52, 4, token_type::kw_true},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {119, 8, token_type::kw_readonly},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {191, 9, token_type::kw_namespace},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {395, 6, token_type::kw_bigint},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {286, 3, token_type::kw_for},
            {358, 11, token_type::kw_constructor},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {322, 6, token_type::kw_delete},
            {328, 7, token_type::kw_default},
            {0, 0, token_type::identifier},
            {97, 9, token_type::kw_satisfies},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {209, 5, token_type::kw_keyof},
            {274, 8, token_type::kw_function},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {56, 5, token_type::kw_throw},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {232, 10, token_type::kw_instanceof},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {164, 3, token_type::kw_out},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {49, 3, token_type::kw_try},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {18, 3, token_type::kw_var},
            {0, 0, token_type::identifier},
            {314, 4, token_type::kw_enum},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {47, 2, token_type::kw_of},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {63, 2, token_type::kw_is},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {28, 6, token_type::kw_unique},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {411, 6, token_type::kw_assert},
            {0, 0, token_type::identifier},
            {179, 4, token_type::kw_null},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {5, 4, token_type::kw_with},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {289, 7, token_type::kw_finally},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {247, 6, token_type::kw_import},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {350, 8, token_type::kw_continue},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {296, 5, token_type::kw_false},
            {379, 4, token_type::kw_case},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {65, 6, token_type::kw_symbol},
            {200, 6, token_type::kw_module},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {133, 9, token_type::kw_protected},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {183, 3, token_type::kw_new},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {94, 3, token_type::kw_set},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {271, 3, token_type::kw_get},
            {0, 0, token_type::identifier},
            {206, 3, token_type::kw_let},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {39, 2, token_type::kw_in},
            {0, 0, token_type::identifier},
            {369, 5, token_type::kw_class},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {106, 6, token_type::kw_return},
            {371, 2, token_type::kw_as},
            {0, 0, token_type::identifier},
            {342, 8, token_type::kw_debugger},
            {0, 0, token_type::identifier},
            {186, 5, token_type::kw_never},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {383, 5, token_type::kw_break},
            {223, 9, token_type::kw_interface},
            {0, 0, token_type::identifier},
            {43, 6, token_type::kw_typeof},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {9, 5, token_type::kw_while},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {122, 2, token_type::kw_do},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {418, 3, token_type::kw_any},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {242, 5, token_type::kw_infer},
            {265, 6, token_type::kw_global},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {411, 7, token_type::kw_asserts},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {21, 7, token_type::kw_unknown},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {282, 4, token_type::kw_from},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {0, 5, token_type::kw_yield},
            {77, 5, token_type::kw_super},
            {0, 0, token_type::identifier},
            {0, 0, token_type::identifier},
            {43, 4, token_type::kw_type},
            {173, 6, token_type::kw_number},
        },

    .string_table =
        u8"yield"
        u8"with"
        u8"while"
        u8"void"
        u8"var"
        u8"unknown"
        u8"unique"
        u8"undefined"
        u8"typeof"
        u8"try"
        u8"true"
        u8"throw"
        u8"this"
        u8"symbol"
        u8"switch"
        u8"super"
        u8"string"
        u8"static"
        u8"set"
        u8"satisfies"
        u8"return"
        u8"require"
        u8"readonly"
        u8"public"
        u8"protected"
        u8"private"
        u8"package"
        u8"override"
        u8"out"
        u8"object"
        u8"number"
        u8"null"
        u8"new"
        u8"never"
        u8"namespace"
        u8"module"
        u8"let"
        u8"keyof"
        u8"intrinsic"
        u8"interface"
        u8"instanceof"
        u8"infer"
        u8"import"
        u8"implements"
        u8"if"
        u8"global"
        u8"get"
        u8"function"
        u8"from"
        u8"for"
        u8"finally"
        u8"false"
        u8"extends"
        u8"export"
        u8"enum"
        u8"else"
        u8"delete"
        u8"default"
        u8"declare"
        u8"debugger"
        u8"continue"
        u8"constructor"
        u8"class"
        u8"catch"
        u8"case"
        u8"break"
        u8"boolean"
        u8"bigint"
        u8"await"
        u8"async"
        u8"asserts"
        u8"any"
        u8"abstract"
        u8"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
};
// clang-format on
}

token_type lexer::identifier_token_type(string8_view identifier) noexcept {
  std::size_t identifier_size = identifier.size();

  keyword_lexer::selection_type selection =
      keyword_lexer::select(identifier.data(), identifier_size);
  keyword_lexer::hash_type hash = keyword_lexer::mix(selection, hash_seed);
  keyword_lexer::hash_type index =
      static_cast<keyword_lexer::hash_type>(hash % hash_table_size);

  const entry& e = tables.hash_table[index];
  const char8* e_key = &tables.string_table[e.key_index];

  // NOTE(strager): Use a result variable to encourage compilers to generate
  // conditional store instructions. Conditional stores can improve performance
  // significantly because lookups are somewhat unpredictable. (Unfortunately,
  // no compiler reliably generates conditional stores.)
  token_type result = e.value;
  if (!keyword_lexer::key_strings_equal(e_key, identifier.data(),
                                        identifier_size)) {
    result = token_type::identifier;
  }
  if (identifier_size != e.key_length) {
    result = token_type::identifier;
  }
  return result;
}
}

// quick-lint-js finds bugs in JavaScript programs.
// Copyright (C) 2020  Matthew "strager" Glazar
//
// This file is part of quick-lint-js.
//
// quick-lint-js is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// quick-lint-js is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.
